From d509af4321f6221e5e59b27078a07ecee14dd713 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?J=C3=A9r=C3=B4me=20Duval?= <jerome.duval@gmail.com>
Date: Fri, 22 Apr 2022 10:10:11 +0200
Subject: [PATCH] intel_extreme: handle combination mode on i965GM

bug #17622

4	1	headers/private/graphics/intel_extreme/intel_extreme.h
4	0	src/add-ons/accelerants/intel_extreme/mode.cpp

diff --git a/headers/private/graphics/intel_extreme/intel_extreme.h b/headers/private/graphics/intel_extreme/intel_extreme.h
index bc58da1a2d..e8ca9531da 100644
--- a/headers/private/graphics/intel_extreme/intel_extreme.h
+++ b/headers/private/graphics/intel_extreme/intel_extreme.h
@@ -1508,7 +1508,10 @@ struct intel_brightness_legacy {
 #define PCH_SOUTH_BLC_PWM_PERIOD		(0x8254 | REGS_SOUTH_SHARED) // Linux _BXT_BLC_PWM_FREQ1
 #define PCH_SOUTH_BLC_PWM_DUTY_CYCLE	(0x8258 | REGS_SOUTH_SHARED) // Linux _BXT_BLC_PWM_DUTY1
 
-#define MCH_BLC_PWM_CTL                 (0x1254 | REGS_NORTH_PIPE_AND_PORT)
+#define MCH_BLC_PWM_CTL2				(0x1250 | REGS_NORTH_PIPE_AND_PORT)
+#define BLM_COMBINATION_MODE			(1 << 30)
+
+#define MCH_BLC_PWM_CTL					(0x1254 | REGS_NORTH_PIPE_AND_PORT)
 	// Linux VLV_BLC_PWM_CTL (one register per pipe) or BLC_PWM_CTL (a single register that can be
 	// programmed for use on either pipe)
 #define BLM_LEGACY_MODE					(1 << 16)
diff --git a/src/add-ons/accelerants/intel_extreme/mode.cpp b/src/add-ons/accelerants/intel_extreme/mode.cpp
index 0777fd7b42..8fc88dde06 100644
--- a/src/add-ons/accelerants/intel_extreme/mode.cpp
+++ b/src/add-ons/accelerants/intel_extreme/mode.cpp
@@ -640,6 +640,8 @@ intel_set_brightness(float brightness)
 			|| gInfo->shared_info->device_type.IsModel(INTEL_MODEL_915M)
 			|| gInfo->shared_info->device_type.IsModel(INTEL_MODEL_945M)) {
 			legacyMode = (tmp & BLM_LEGACY_MODE) != 0;
+		} else if (gInfo->shared_info->device_type.Generation() == 4) {
+			legacyMode = (read32(MCH_BLC_PWM_CTL2) & BLM_COMBINATION_MODE) != 0;
 		}
 
 		uint32_t period = tmp >> 16;
@@ -700,6 +702,8 @@ intel_get_brightness(float* brightness)
 			|| gInfo->shared_info->device_type.IsModel(INTEL_MODEL_915M)
 			|| gInfo->shared_info->device_type.IsModel(INTEL_MODEL_945M)) {
 			legacyMode = (tmp & BLM_LEGACY_MODE) != 0;
+		} else if (gInfo->shared_info->device_type.Generation() == 4) {
+			legacyMode = (read32(MCH_BLC_PWM_CTL2) & BLM_COMBINATION_MODE) != 0;
 		}
 		period = tmp >> 16;
 		duty = read32(intel_get_backlight_register(false)) & 0xffff;
-- 
2.11.0

